<?php

namespace Drupal\Tests\cryptolog\Functional;

use PHPUnit\Framework\SkippedTestError;

/**
 * Tests Cryptolog with the Redis contributed module.
 *
 * @group cryptolog
 * @requires module redis
 */
class CryptologRedisTest extends CryptologTest {

  /**
   * Additional module to enable.
   */
  const MODULE = 'redis';

  /**
   * {@inheritdoc}
   */
  protected $eventId = 2;

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();
    // @fixme The following three lines can be removed if/when modules are
    // restored as test dependencies or if/when an undefined array key bug
    // in core ModuleInstaller is fixed.
    if (!isset($this->container->get('extension.list.module')->reset()->getList()[static::MODULE])) {
      throw new SkippedTestError('Required Drupal module: ' . static::MODULE);
    }
    if (extension_loaded('redis')) {
      $this->container->get('module_installer')->install([static::MODULE]);
    }
    else {
      throw new SkippedTestError('Required PHP extension: redis');
    }
  }

}
